<template>
  <Button
    icon="pi pi-book"
    iconPos="left"
    label="Ajouter un mot dans le dictionnaire"
    class="p-button-primary"
    @click="visible = true"
  />
  <Dialog v-model:visible="visible">
    <template #header>
      <h3>Ajout d'un mot dans le dictionnaire</h3>

      <Button
        :loading="formLoading"
        :disabled="phoneticWord.length == 0 || writtenWord.length == 0"
        label="Ajouter mot au dictionnaire"
        class="p-button-primary"
        @click="this.handleAddWord"
      />
    </template>

    <h5 :class="validationClass">Tous les champs sont obligatoires</h5>
    <div class="flex headerBottom">
      <div class="flex-1">
        <h5 for="newWord" class="mb-0">Nouveau mot</h5>
        <InputText
            id="newWord"
            type="text"
            v-model="writtenWord"
            placeholder="Ecriture alphabétique"
            :class="alphaClass"
          />
      </div>
      <div class="flex-1">
        <h5 for="newWord" class="mb-2">Mot Polysyllabique (à partir de 3 syllabes)</h5>
        <Checkbox id="binary" v-model="poly_syll" :binary="true" />
        <label class="ml-1 pointer" for="binary">Polysyllabique</label>
      </div>
    </div>

    <!--<h5 for="minmax-syllabel" class="mb-0">Nombre de syllabes</h5>
    <div class="flex flex-direction-row">
      <InputNumber
        id="minmax-syllabel"
        v-model="syllabelCount"
        mode="decimal"
        showButtons
        :min="0"
        :max="20"
        :class="syllabelClass"
      />

      <p class="form-error" v-if="formError">{{ formError }}</p>
    </div>-->

    <h5 for="minmax-syllabel" class="mb-0">Ecriture phonétique</h5>
    <InputText
          type="text"
          v-model="phoneticWord"
          placeholder="Ecriture phonétique"
          :class="phoneticClass"
        />
      <h5 class="m-0 pointer" @click="showPhonem = !showPhonem"><span v-if="!showPhonem">Afficher</span><span v-else>Masquer</span> clavier phonétique</h5>
      <div class="resultPhonem">
        <h3>Résultat: <strong><span v-for="(item, index) in phoneticWord" :key="index">{{ translate[item] }}</span></strong></h3>
      </div>

      <div v-if="showPhonem" class="showPhonem">
        <hr>
        <div>
          <h3 class="mb-1">Voyelles orales</h3>
          <div class="gridPhonem">
            <div class="phonemVo" v-for="(item, index) in phonemTable.voyelle" :key="index" @click="phoneticWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
          </div>
        </div>
        <div class="gridVoy mt-2">
          <div>
            <h3 class="mb-1">Voyelles Nasales</h3>
            <div class="gridPhonemThree">
              <div class="phonemVn" v-for="(item, index) in phonemTable.voyelleNas" :key="index" @click="phoneticWord += item.id">
                <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
                <div>{{ item.exemple }}</div>
              </div>
            </div>
          </div>
          <div>
            <h3 class="mb-1">Semi-Consonnes</h3>
            <div class="gridPhonemThree">
              <div class="phonemCsv" v-for="(item, index) in phonemTable.semivoyelle" :key="index" @click="phoneticWord += item.id">
                <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
                <div>{{ item.exemple }}</div>
              </div>
            </div>
          </div>
        </div>
        <div class="mt-2">
          <h3 class="mb-1">Consonnes</h3>
          <div class="gridPhonem">
            <div class="phonemCo" v-for="(item, index) in phonemTable.consCo" :key="index" @click="phoneticWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCc" v-for="(item, index) in phonemTable.consCc" :key="index" @click="phoneticWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCl" v-for="(item, index) in phonemTable.consCl" :key="index" @click="phoneticWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCn" v-for="(item, index) in phonemTable.consCn" :key="index" @click="phoneticWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCs" v-for="(item, index) in phonemTable.consCs" :key="index" @click="phoneticWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
          </div>
        </div>
      </div>

    <template #footer>
      <Button
        :loading="formLoading"
        :disabled="phoneticWord.length == 0 || writtenWord.length == 0"
        label="Ajouter mot au dictionnaire"
        class="p-button-primary mt-2"
        @click="this.handleAddWord"
      />
    </template>
  </Dialog>
</template>

<script>
import Checkbox from 'primevue/checkbox';
import Button from "primevue/button";
import Dialog from "primevue/dialog";
import InputText from "primevue/inputtext";
import InputNumber from "primevue/inputnumber";
import axios from 'axios'

export default {
  name: "Add Word To Dictionnary",
  components: {
    Button,
    Dialog,
    InputText,
    InputNumber,
    Checkbox
  },
  data() {
    return {
      poly_syll: false,
      visible: false,
      writtenWord: "",
      phoneticWord: "",
      struct_syll_type: "",
      struct_syll: "",
      syllabelCount: 0,
      validationClass: "validate-input",
      alphaClass: "validate-alpha",
      phoneticClass: "validate-phonetic",
      syllabelClass: "validate-syllabel",
      formLoading: false,
      formError: null,

      showPhonem: true,
      phonemTable: {
        voyelle: [
          {id: "i", phonem: "i", exemple: "si"},
          {id: "e", phonem: "e", exemple: "pré"},
          {id: "E", phonem: "ɛ", exemple: "père"},
          {id: "a", phonem: "a", exemple: "mal"},
          {id: "y", phonem: "y", exemple: "tu"},
          {id: "2", phonem: "ø", exemple: "peu"},
          {id: "°", phonem: "ə", exemple: "je"},
          {id: "9", phonem: "œ", exemple: "soeur"},
          {id: "u", phonem: "u", exemple: "cou"},
          {id: "o", phonem: "o", exemple: "zéro"},
          {id: "O", phonem: "ɔ", exemple: "sort"},
        ],
        voyelleNas: [
          {id: "5", phonem: "ɛ̃", exemple: "pain"},
          {id:"@", phonem: "ɑ̃", exemple: "blanc"},
          {id: "§", phonem: "ɔ̃", exemple: "pont"},
        ],
        semivoyelle: [
          {id: "8", phonem: "ɥ", exemple: "huit"},
          {id: "w", phonem: "w", exemple: "oiseau"},
          {id: "j", phonem: "j", exemple: "fille"}
        ],
        consCo: [
          {id: "p", phonem: "p", exemple: "pile"},
          {id: "b", phonem: "b", exemple: "bateau"},
          {id: "t", phonem: "t", exemple: "tout"},
          {id: "d", phonem: "d", exemple: "deux"},
          {id: "k", phonem: "k", exemple: "calme"},
          {id: "g", phonem: "g", exemple: "gâteau"},
        ],
        consCc: [
          {id: "f", phonem: "f", exemple: "fou"},
          {id: "v", phonem: "v", exemple: "va"},
          {id: "s", phonem: "s", exemple: "site"},
          {id: "z", phonem: "z", exemple: "zut"},
          {id: "S", phonem: "ʃ", exemple: "chocolat"},
          {id: "Z", phonem: "ʒ", exemple: "genou"},
        ],
        consCl: [
          {id: "R", phonem: "ʁ", exemple: "rue"},
          {id: "l", phonem: "l", exemple: "lit"}
        ],
        consCn: [
          {id: "m", phonem: "m", exemple: "mode"},
          {id: "n", phonem: "n", exemple: "nez"},
          {id: "N", phonem: "ɲ", exemple: "agneau"},
        ],
        consCs: [
          {id: "K", phonem: "ŋ", exemple: "parking"}
        ]
      },

      struct_syll_table: {
        "a": "V",
        "i": "V",
        "y": "V",
        "u": "V",
        "o": "V",
        "O": "V",
        "e": "V",
        "E": "V",
        "°": "V",
        "2": "V",
        "9": "V",

        "5": "V",
        "@": "V",
        "§": "V",

        "j": "C",
        "8": "C",
        "w": "C",

        "p": "C",
        "b": "C",
        "t": "C",
        "d": "C",
        "k": "C",
        "g": "C",

        "f": "C",
        "v": "C",
        "s": "C",
        "z": "C",
        "S": "C",
        "Z": "C",

        "m": "C",
        "n": "C",
        "N": "C",

        "l": "C",
        "R": "C",

        "K": "C",
      },

      struct_syll_type_table: {
        "a": "Vo",
        "i": "Vo",
        "y": "Vo",
        "u": "Vo",
        "o": "Vo",
        "O": "Vo",
        "e": "Vo",
        "E": "Vo",
        "°": "Vo",
        "2": "Vo",
        "9": "Vo",

        "5": "Vn",
        "@": "Vn",
        "§": "Vn",

        "j": "Csv",
        "8": "Csv",
        "w": "Csv",

        "p": "Co",
        "b": "Co",
        "t": "Co",
        "d": "Co",
        "k": "Co",
        "g": "Co",

        "f": "Cc",
        "v": "Cc",
        "s": "Cc",
        "z": "Cc",
        "S": "Cc",
        "Z": "Cc",

        "m": "Cn",
        "n": "Cn",
        "N": "Cn",

        "l": "Cl",
        "R": "Cl",

        "K": "Cs",
      },

      translate: {
        "a": "a",
        "i": "i",
        "y": "y",
        "u": "u",
        "o": "o",
        "O": "ɔ",
        "e": "e",
        "E": "ɛ",
        "°": "ə",
        "2": "ø",
        "9": "œ",
        "1": "œ̃",
        "3": "",

        "5": "ɛ̃",
        "@": "ɑ̃",
        "§": "ɔ̃",

        "j": "j",
        "8": "ɥ",
        "w": "w",

        "p": "p",
        "b": "b",
        "t": "t",
        "d": "d",
        "k": "k",
        "g": "g",

        "f": "f",
        "v": "v",
        "s": "s",
        "z": "z",
        "S": "ʃ",
        "Z": "ʒ",

        "m": "m",
        "n": "n",
        "N": "ɲ",

        "l": "l",
        "R": "ʁ",

        "K": "ŋ",

        "x": "",
        "G": ""
    },

      struct_syll: "",
      struct_syll_type: ""
    };
  },

  methods: {
    async handleAddWord() {
      this.formLoading = true
      this.formError = null
      if (
        this.writtenWord === "" ||
        this.phoneticWord === "" 
      ) {
        this.formLoading = false
        this.validationClass = "non-validate-input";
        this.writtenWord === ""
          ? (this.alphaClass = "non-validate-alpha")
          : (this.alphaClass = "validate-alpha");
        this.phoneticWord === ""
          ? (this.phoneticClass = "non-validate-phonetic")
          : (this.phoneticClass = "validate-phonetic");
        this.syllabelCount === 0
          ? (this.syllabelClass = "non-validate-syllabel")
          : (this.syllabelClass = "validate-syllabel");
      } else {
        for (let i = 0; i < this.phoneticWord.length; i++) {
          this.struct_syll += this.struct_syll_table[this.phoneticWord[i]];
          this.struct_syll_type += this.struct_syll_type_table[this.phoneticWord[i]];
          if (this.struct_syll_table[this.phoneticWord[i]] == "V") {
            this.syllabelCount += 1
          }
        }

        await axios.put('/mots/create', {
          orthographe: this.writtenWord,
          nb_syll: this.syllabelCount,
          struct_syll: this.struct_syll,
          struct_syll_type: this.struct_syll_type,
          poly_syll: this.poly_syll,
          phonem: this.phoneticWord,
          id_ortho: this.$store.state.user.id
        }).then(res => {
          this.$store.commit('addNewMot', {mot: res.data})
          this.writtenWord = "";
          this.phoneticWord = "";
          this.struct_syll_type = "";
          this.struct_syll = "";
          this.poly_syll = false
          this.syllabelCount = 0;
          this.validationClass = "validate-input";
          this.alphaClass = "validate-alpha";
          this.phoneticClass = "validate-phonetic";
          this.syllabelClass = "validate-syllabel";
          this.visible = false;
          this.formLoading = false
          axios.post("/mots/check", {bdd_version: this.$store.state.motsVersion}).then(res => {
            if (!res.data.valid) {
              this.$store.commit('importMots', {mots: res.data.complete.mots, bdd_version: res.data.complete.bdd_version})
            }
          }).catch(err => {
            this.formError = "Une erreur est survenue"
            console.log(err)
            this.formLoading = false
          })
        }).catch (err => {
          if ('detail' in err.response.data && err.response.data.detail == "Mot already exist") {
            this.formLoading = false
            this.formError = "Ce mot existe déjà"
          } else {
            this.formLoading = false
            alert(JSON.stringify(err))
            console.log(err)
          }
        })
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.p-inputtext {
  margin-right: 0.5rem !important;
}
</style>

<style lang="scss">
.resultPhonem {
  display: flex;
  justify-content: center;
}
.headerBottom {
  margin-top: -10px !important;
}
.showPhonem {
  user-select: none;
  width: 700px;
}
.gridVoy {
  display: grid;
  grid-template-columns: repeat(2, minmax(0, 1fr));
  gap: 1rem;
}
.gridPhonem {
  display: grid;
  grid-template-columns: repeat(6, minmax(0, 1fr));
  gap: 1rem;
}
.gridPhonemThree {
  display: grid;
  grid-template-columns: repeat(3, minmax(0, 1fr));
  gap: 1rem;
}

.phonemVo {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  background-color: yellow;
  border-radius: 5px;
}
.phonemVo:hover {
  background-color: #ffffb7;
}

.phonemCsv {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  background-color: skyblue;
  border-radius: 5px;
}
.phonemCsv:hover {
  background-color: #add7e7;
}
.phonemVn {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  color: aliceblue;
  background-color: blue;
  border-radius: 5px;
}
.phonemVn:hover {
  background-color: #4747ff;
}

.phonemCo {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  color: aliceblue;
  background-color: red;
  border-radius: 5px;
}
.phonemCo:hover {
  background-color: #ff6565;
}
.phonemCc {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  color: aliceblue;
  background-color: purple;
  border-radius: 5px;
}
.phonemCc:hover {
  background-color: #cf00cf;
}
.phonemCl {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  color: white;
  background-color: #008000 ;
  border-radius: 5px;
}
.phonemCl:hover {
  background-color: #00cc00;
}
.phonemCn {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  background-color: #ffa500;
  border-radius: 5px;
}
.phonemCn:hover {
  background-color: #fcc867;
}
.phonemCs {
  padding: 5px;
  cursor: pointer;
  text-align: center;
  color: aliceblue;
  background-color: #00008b;
  border-radius: 5px;
}
.phonemCs:hover {
  background-color: #0000cf;
}

.pointer {
  cursor: pointer;
}

.validate-input {
  display: none;
}

.non-validate-input {
  color: red;
}

.non-validate-alpha {
  border-color: red;
}
.non-validate-phonetic {
  border-color: red;
}
.non-validate-syllabel > input {
  border-color: red;
}

.form-error {
  color: red;
  font-size: 14px
}
</style>